/**
 * generated by Xtext 2.25.0
 */
package org.xtext.example.methodname.methodName;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>And</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.xtext.example.methodname.methodName.And#getLeft <em>Left</em>}</li>
 *   <li>{@link org.xtext.example.methodname.methodName.And#getConcatKind <em>Concat Kind</em>}</li>
 *   <li>{@link org.xtext.example.methodname.methodName.And#getRight <em>Right</em>}</li>
 * </ul>
 *
 * @see org.xtext.example.methodname.methodName.MethodNamePackage#getAnd()
 * @model
 * @generated
 */
public interface And extends Expr
{
  /**
   * Returns the value of the '<em><b>Left</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Left</em>' containment reference.
   * @see #setLeft(Expr)
   * @see org.xtext.example.methodname.methodName.MethodNamePackage#getAnd_Left()
   * @model containment="true"
   * @generated
   */
  Expr getLeft();

  /**
   * Sets the value of the '{@link org.xtext.example.methodname.methodName.And#getLeft <em>Left</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Left</em>' containment reference.
   * @see #getLeft()
   * @generated
   */
  void setLeft(Expr value);

  /**
   * Returns the value of the '<em><b>Concat Kind</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Concat Kind</em>' attribute.
   * @see #setConcatKind(String)
   * @see org.xtext.example.methodname.methodName.MethodNamePackage#getAnd_ConcatKind()
   * @model
   * @generated
   */
  String getConcatKind();

  /**
   * Sets the value of the '{@link org.xtext.example.methodname.methodName.And#getConcatKind <em>Concat Kind</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Concat Kind</em>' attribute.
   * @see #getConcatKind()
   * @generated
   */
  void setConcatKind(String value);

  /**
   * Returns the value of the '<em><b>Right</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Right</em>' containment reference.
   * @see #setRight(Expr)
   * @see org.xtext.example.methodname.methodName.MethodNamePackage#getAnd_Right()
   * @model containment="true"
   * @generated
   */
  Expr getRight();

  /**
   * Sets the value of the '{@link org.xtext.example.methodname.methodName.And#getRight <em>Right</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Right</em>' containment reference.
   * @see #getRight()
   * @generated
   */
  void setRight(Expr value);

} // And
